# -*- coding: iso-8859-15 -*-

##########################
# TP 5 : Arbres binaires #
##########################

#---------------------------
# Structure d'arbre binaire
#---------------------------

class Noeud:
    def __init__(self,val,gauche=None,droit=None):
	# Par dfaut le noeud est une feuille de l'arbre
        self.val=val # Valeur du noeud
        self.gauche=gauche # Pointeur vers le sous-arbre gauche
        self.droit=droit # Pointeur vers le sous-arbre droit

arbre1=Noeud('*',Noeud('+',Noeud(3),Noeud(2)),Noeud('-',Noeud(4),Noeud(1)))

arbre2=Noeud(1,Noeud(2,Noeud(3),Noeud(3,Noeud(4,Noeud(5)),Noeud(4,Noeud(5),Noeud(5)))),Noeud(2,Noeud(3,Noeud(4),Noeud(4,Noeud(5))),Noeud(3,Noeud(4))))

arbre3=Noeud(1,Noeud(2,Noeud(4),Noeud(5,Noeud(8,Noeud(14)),Noeud(9,Noeud(15),Noeud(16)))),Noeud(3,Noeud(6,Noeud(11,Noeud(17)),Noeud(12,Noeud(18),Noeud(19,Noeud(20)))),Noeud(7,Noeud(13))))

arbre4=Noeud(1,Noeud(2),Noeud(3,Noeud(4),Noeud(5)))

#------------
# Exercice 1
#------------

# 1. Sur une feuille, dessiner les arbres arbre1, arbre2 et arbre3

# 2. Ecrire une procdure prefixe(t) affichant les noeuds de l'arbre dans l'ordre prfix

def prefixe(t):
    if t==None:
        return
    print(t.val,end=' ')
    prefixe(t.gauche)
    prefixe(t.droit)

# 3. Ecrire une procdure infixe(t) affichant les noeuds de l'arbre dans l'ordre infix

def infixe(t):
    if t==None:
        return
    infixe(t.gauche)
    print(t.val,end=' ')
    infixe(t.droit)
    
# 4. Ecrire une procdure postfixe(t) affichant les noeuds de l'arbre dans l'ordre postfix

def postfixe(t):
    if t==None:
        return
    postfixe(t.gauche)
    postfixe(t.droit)
    print(t.val,end=' ')
    
# 5. Ecrire une fonction nombre_noeuds(t) qui retourne le nombre de noeuds de l'arbre t

def nombre_noeuds(t):
    if t==None:
        return 0
    return 1+nombre_noeuds(t.gauche)+nombre_noeuds(t.droit)

# 6. Ecrire une fonction nombre_feuilles(t) qui retourne le nombre de feuilles de l'arbre t

def nombre_feuilles(t):
    if t==None:
        return 0
    if t.gauche==None and t.droit==None:
        return 1
    return nombre_feuilles(t.gauche)+nombre_feuilles(t.droit)

# 7. Ecrire une fonction nombre_noeud_internes(t) qui retourne le nombre de noeuds internes de t

def nombre_noeud_internes(t):
    if t==None:
        return 0
    if t.gauche==None and t.droit==None:
        return 0
    return 1+nombre_noeud_internes(t.gauche)+nombre_noeud_internes(t.droit)

#------------
# Exercice 2
#------------

# 1. Ecrire une fonction hauteur(t) qui retourne la hauteur de l'arbre t

def hauteur(t):
    if t==None:
        return -1
    return 1+max(hauteur(t.gauche),hauteur(t.droit))

# 2. Ecrire une fonction combien(t,p) qui retourne le nombre de
#    noeuds de t qui sont exactement  la profondeur p

def combien(t,p):
    if p<0 or t==None:
        return 0
    if p==0:
        return 1
    return combien(t.gauche,p-1)+combien(t.droit,p-1)

# 3. Ecrire une fonction noeuds(t,p) qui retourne les noeuds de t
#    qui sont exactement  la profondeur p

def noeuds(t,p):
    if p<0 or t==None:
        return []
    if p==0:
        return [t.val]
    return noeuds(t.gauche,p-1)+noeuds(t.droit,p-1)

#------------
# Exercice 3
#------------

# 1. Ecrire une fonction est_entier(t) qui teste si l'arbre binaire t est entier.

def est_entier(t):
    if t==None:
        return True
    if (t.gauche==None and t.droit!=None) or (t.gauche!=None and t.droit==None):
        return False
    return est_entier(t.gauche) and est_entier(t.droit)
    

# 2. Un arbre binaire est quilibr si en tout noeud de l'arbre la diffrence des hauteurs
#    de ses deux sous-arbres est d'au plus 1. Ecrire une fonction est_equilibre(t) qui teste
#    si l'arbre t est quilibr.

#----------------
# Structure Pile
#----------------

# Une pile est un conteneur possdant 4 oprations
# push(x) permettant d'ajouter la valeur x en haut de la pile
# top() retournant la valeur du haut de la pile
# pop() retirant la valeur du haut de la pile
# empty() testant si la pile est vide ou pas

class Pile:
    def __init__(self):
        self.data=[]
        
    def push(self,x):
        self.data.append(x)
    
    def top(self):
        return self.data[-1]
        
    def pop(self):
        self.data.pop()
        
    def empty(self):
        return len(self.data)==0

#------------
# Exercice 4
#------------

# En utilisant une pile, crire une fonction  prefixe2(t) non rcursive affichant les noeuds
# de l'arbre t dans l'ordre prfix.

def prefixe2(t):
    p=Pile()
    p.push(t)
    while not p.empty():
        current=p.top()
        p.pop()
        if current!=None:
            print(current.val)
            p.push(current.droit)
            p.push(current.gauche)
        
        
#------------
# Exercice 5
#------------

# On peut reprsenter une expression arithmtique contenant que des oprateurs binaires +,*,-,
# des chiffres et des parenthses  l'aide d'un arbre binaire.

# 1. Quelle expression arithmtique reprsente l'arbre arbre1 ?

#

# 2. Ecrire une fonction evalue(t) qui tant donn l'arbre t d'une expression arithmtique retourne
#    la valeur de celle-ci.

def evalue(t):
    if t==None:
        return 0
    if t.droit==None and t.gauche==None:
        return t.val
    a=evalue(t.gauche)
    b=evalue(t.droit)
    if t.val=='+':
        return a+b
    if t.val=='*':
        return a*b
    if t.val=='-':
        return a-b
    
if __name__=="__main__":
    print(est_entier(arbre1))
    print(est_entier(arbre2))
    print(est_entier(arbre3))
    print(est_entier(arbre4))

    prefixe2(arbre1)
    print(evalue(arbre1))
